07/04/94

    GETDESC  Maximus files.bbs --> 4DOS descript.ion utility, ver. 0.82/b4
    Copyright (C) 1993,94 by Jim Whitelaw of 1:342/42. All rights reserved.

This is all the documentation you get, enjoy it. 8-)

*** Overview: ***

GETDESC is a small utility that can help you to keep your 4DOS file
descriptions (in descript.ion files) up to date for BBS file areas. It will
copy the entries in a Maximus-type (others too, probably, but I haven't
tested it) files.bbs file in to a 4DOS descript.ion file. It will, at your
option, strip out or leave in any "free time and/or bytes" desginators
found in the files.bbs entry and any type of download counters. Perhaps the
most convenient feature of GETDESC is that in addition to processing single
file areas, it can also read a Maximus 2.0x area.dat type file to find all
of your file areas, and it will process them all at once, saving you a
whole lot of directory changing to get your descriptions written.


*** History: ***

GETDESC started out as a 4DOS btm written by Klaus Kettner, called
FBBS2DES.BTM, and posted in the 4DOS echo. I thought it was a good idea,
and I made a few changes to it, adding a number of features. (Specifically,
the ability to strip any "free time and bytes" designators, and to strip
download counters). The latest version of GETDESC.BTM is included in this
archive, for those that are curious to see what it looks like. However,
because of the way that 4DOS uses commas as a type of string separator,
GETDESC.BTM will choke on any files.bbs description that contains a comma.
So in order for it to work properly, you have to make sure that none of
your descriptions contain commas.

That got to be a bit of a pain for me, and I had just bought Borland Turbo
C++ and was anxious to try it out. So I re-wrote GETDESC in C++, primarily
as a learning exercise.

GETDESC.EXE, in addition to handling commas properly, also has the
advantage of being much faster than the btm version. Because of this, there
is no fancy display stuff in GETDESC.EXE, since hopefully you won't have
time to see it anyway.


*** Usage: ***

GETDESC reads files.bbs and creates corresponding 4DOS descriptions
in descript.ion. If no parameters are used, GETDESC defaults to
processing all files listed in files.bbs that exist in the current
directory, strips any /t, /b or /tb desginators, and leaves the download
counters in the description. If the /f option is used, GETDESC will use
the specified Maximus 2.0x AREA.DAT file to find your files.bbs files,
and will place new descript.ion files in the appropriate file area.

Syntax:
GETDESC [/f<filename>] [/s] [/c<char>] [/l] [/n] [/x<drive(s)>] [/?]

/f<filename> - name of Maximus 2.0x AREA.DAT file to use
/s           - Strip download counters from description
/c<char>     - Counter bracket type - can be "{", "(", or "[" (default).
/l           - Leave /t, /b, or /tb designators in description.
/n           - No checking for existence of listed files (faster).
/x<drive(s)> - eXclude <drive(s)> from processing - IE: /xg to skip drive G:
               (valid only with the /f option).
/?           - View help message


A few words of explanation:

When using the /f option, GETDESC has the ability to read a Maximus 2.0x
area.dat type file to locate your file areas. When doing so, it will
process all file directories listed in the area.dat file at once.
If the area.dat is not in the current directory, a full pathname must be
specified. It doesn't matter what directory you run GETDESC from if you are
using the /f option; GETDESC always uses full pathnames when writing
descriptions.

When using the area.dat file, GETDESC will use the filelist specified by
the FileList keyword in filearea.ctl, and place the descript.ion file in
the directory specified with the Download keyword. If no FileList is
specified, GETDESC assumes that the filelist is called "files.bbs" and is
in the Download directory.

If the Download directory is on a CD-ROM drive, you will want to exclude it
from processing, since it is not possible to write the descript.ion files.
You do this with the /x switch. For instance, to exclude a CD-ROM drive G:
from processing, you would use "GETDESC /farea.dat /xg". This option is
only valid when using the area.dat file, and up to 8 drives may be
excluded. IE: "/xefgh" will exclude drives E:, F:, G:, and H: from
processing.

To process only a single file area, simply change to that directory, and
run GETDESC without the /f parameter. Only the current directory will be
processed.

When using the /s (strip download counters) option, any "free time and
bytes" designators will be stripped as well. It is not possible to strip
the counters *and* leave the freebie designators in. You can, however,
strip the freebie designators and leave the counters in. Got it?

When searching for and stripping download counters, GETDESC defaults to
using counters that look like this: [  ]. Any width, it doesn't matter. If
you use a different type, like {  } or (  ) and want to strip them, you
need to specify that on the commandline with /c{ or /c(, whichever is
appropriate. If you don't, no harm will be done, but neither will any good;
you will get useless descript.ion files. 8-)

When stripping the freebie designators, *all* designator types (/t, /b, and
/tb) will be stripped.

There is a feature in Maximus (undocumented, I believe) that allows you to
specify a full pathname in files.bbs, listing a file in a directory other
than the current file area. For instance, I have a POINT file area
d:\max\file\point\, for which some of the files.bbs entries look like this:

d:\max\file\sdsbink\BDOC_250.LZH [ 2] BinkleyTerm 2.50 docs
d:\max\file\sdsbink\BEXE_250.LZH [ 2] BinkleyTerm 2.50 executables
d:\max\file\sdsbink\BNKB_256.LZH [ 3] BinkleyTerm 2.56 wide beta version

Obviously, it would do no good to write descript.ion entries for these
files in the d:\max\file\point\ directory, since the actual files are
located elsewhere. Thus, if GETDESC finds a files.bbs entry beginning with
a drive letter instead of a filename, the entry is skipped.

In addition, by default GETDESC checks to see if the files listed in the
files.bbs listings actually exist in the Download directory before writing
the description. This means that it will never write descript.ion entries
for "missing" or "offline" files. You can override this behaviour by
specifying the /n switch on the commandline. This causes GETDESC to skip
the existence checking routine, which can significantly speed up its
operation.


***Limitations: ***

At the present time, GETDESC has the following hard-coded limits:

Can handle up to 256 file areas when using an area.dat file.

Can read files.bbs descriptions of up to approximately 1K, however, it will
write descriptions no more than 255 characters long which is the Maximus
description length limit.

When processing a single directory, always uses the filenames "files.bbs"
and "descript.ion". This may be configurable in a future version if there
is any demand for it.


***Legal-type stuff: ***

Maximus is a copyright (C) of Scott J. Dudley.
4DOS is a copyright (C) of Rex Conn & J.P. Software.

GETDESC is not public domain, it is a copyrighted program. However, in
accordance with the principles established by Richard Stallman and the Free
Software Foundation, you may use this program for free. You may not sell
this program, nor charge more than 3 (three) Canadian dollars for copying
or distribution services related to this program. If you find this program
useful and wish to show your appreciation, please make a donation to your
local food bank.


===========================================================================

That's about all I can think of right now, If you have any comments,
questions, or bug reports, please feel free to contact me via netmail at
any of the addresses below. I may also be reached via the 4DOS or MUFFIN
echos. The latest version of GETDESC is always available by File Requesting
the magic name "GETDESC".


Jim Whitelaw
Edmonton, Alberta

   FidoNet: 1:342/42
 FamilyNet: 8:7504/9
    LCRnet: 77:1910/53
      IMEX: 89:701/240
       BBS: (403)489-1735 <V32b>


